CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

OBJ
  debug : "FullDuplexSerial"

  MyObj1 : "MyObject1"
  MyObj2 : "MyObject2"


PUB Main
'the FIRST PUB-Method inside a spinfile is ALWAYS the startpoint where the program starts to run
  debug.start(31, 30, 0, 115200)

  MyObj1.Start
  debug.str(string("object 1 started variable counts down"))
  debug.Tx(13)

  MyObj2.Start
  debug.str(string("object 2 started variable counts up"))
  debug.Tx(13)
  debug.Tx(13)


  debug.str(string("--------------------------------------------------",13))
  repeat
    debug.str(string("now we watch for some time how the values "))
    debug.str(string("of the variables in Object 1/2 change"))
    debug.Tx(13)
    debug.Tx(13)

    repeat 10
      WaitCnt(ClkFreq + cnt)
      debug.str(string("Value of Var in Obj1="))
      debug.dec(MyObj1.GetMyVarInObj1)

      debug.str(string(" Value of Var in Obj2="))
      debug.dec(MyObj2.GetMyVarInObj2)

      debug.Tx(13)
      debug.Tx(13)


    debug.str(string("--------------------------------------------------",13))
    debug.str(string("now we WRITE NEW values "))
    debug.str(string("into the variables in Object 1/2 "))
    debug.Tx(13)
    debug.Tx(13)

    MyObj1.SetMyVarInObj1(2000)
    debug.str(string("Value of Var in Obj1 is set to value "))
    debug.dec(2000)
    debug.Tx(13)

    MyObj2.SetMyVarInObj2(300)
    debug.str(string("Value of Var in Obj2 is set to value "))
    debug.dec(300)
    debug.Tx(13)
    debug.Tx(13)
    debug.str(string("--------------------------------------------------",13))

    debug.str(string("now we watch AGAIN for some time how the values "))
    debug.str(string("of the variables in Object 1/2 change"))
    debug.Tx(13)
    debug.Tx(13)

    repeat 10
      WaitCnt(ClkFreq + cnt)
      debug.str(string("Value of Var in Obj1="))
      debug.dec(MyObj1.GetMyVarInObj1)

      debug.str(string(" Value of Var in Obj2="))
      debug.dec(MyObj2.GetMyVarInObj2)

      debug.Tx(13)
      debug.Tx(13)

    debug.str(string("End of Demo",13))
    debug.str(string("--------------------------------------------------",13))
    debug.str(string("--------------------------------------------------",13))
    debug.Tx(13)
    debug.Tx(13)
    debug.Tx(13)

